ReDim Shared As Double Array_1D(5)
ReDim Shared As Double Array_2D(3,3)
Dim As Integer I,J
Array_1D(0) = 60
Array_1D(1) = 10
Array_1D(2) = 20
Array_1D(3) = 30
Array_1D(4) = 40
Array_1D(5) = 50

Array_2D(2,2) = 22

Declare Sub Extend_1dim (Array() As Double,Ilow As Integer,Ihigh As Integer)
Sub Extend_1dim (Array() As Double,Inew_low As Integer,Inew_high As Integer)
  Dim As Integer Iold_low,Iold_high,I
  Dim As Integer Jold_low,Jold_high,J
  Iold_low = Lbound(Array,1)
  Iold_high = Ubound(Array,1)
  If Inew_low > Iold_low Or Inew_high < Iold_high Then
    Print "<E> Extend not performed, New array cuts into the old array."
    Print "    Operation not performed."
  Else
    Redim Work(Iold_low To Iold_high) As Double
    For I = Iold_low To Iold_high
      Work(I) = Array(I)
    Next I
    Redim Array(Inew_low To Inew_high) As Double
    For I = Inew_low To Inew_high
      Array(I) = 0
    Next I
    For I = Iold_low To Iold_high
      Array(I) = Work(I)
    Next I  
    Array(3) = 300
  End If
End Sub


Declare Sub Extend_2dim (Array() As Double,Ilow As Integer,Ihigh As Integer, _
                                           Jlow As Integer,Jhigh As Integer)
Sub Extend_2dim (Array() As Double,Inew_low As Integer,Inew_high As Integer, _
                                   Jnew_low As Integer,Jnew_high As Integer)
  Dim As Integer Iold_low,Iold_high,I
  Dim As Integer Jold_low,Jold_high,J
  Iold_low = Lbound(Array,1)
  Iold_high = Ubound(Array,1)
  Jold_low = Lbound(Array,2)
  Jold_high = Ubound(Array,2)
  If Inew_low > Iold_low Or Inew_high < Iold_high _
    Or Jnew_low > Jold_low Or Jnew_high < Jold_high Then
    Print "<E> Extend not performed, New array cuts into the old array."
    Print "    Operation not performed."
  Else
    Redim Work(Iold_low To Iold_high,Jold_low To Jold_high) As Double
    For I = Iold_low To Iold_high
      For J = Jold_low To Jold_high
        Work(I,J) = Array(I,J)
      Next J  
    Next I
    Redim Array(Inew_low To Inew_high,Jnew_low To Jnew_high) As Double
    For I = Inew_low To Inew_high
      For J= Jnew_low To Jnew_high
        Array(I,J) = 0
      Next J
    Next I
    For I = Iold_low To Iold_high
      For J = Jold_low To Jold_high
        Array(I,J) = Work(I,J)
      Next J  
    Next I  
    Array(3,2) = 300
  End If
End Sub  


Declare Sub Extend_3dim (Array() As Double,Ilow As Integer,Ihigh As Integer, _
                                           Jlow As Integer,Jhigh As Integer, _
                                           Klow As Integer,Khigh As Integer)
Sub Extend_3dim (Array() As Double,Inew_low As Integer,Inew_high As Integer, _
                                   Jnew_low As Integer,Jnew_high As Integer, _
                                   Knew_low As Integer,Knew_high As Integer)
  Dim As Integer Iold_low,Iold_high,I
  Dim As Integer Jold_low,Jold_high,J
  Dim As Integer Kold_low,Kold_high,K
  Iold_low = Lbound(Array,1)
  Iold_high = Ubound(Array,1)
  Jold_low = Lbound(Array,2)
  Jold_high = Ubound(Array,2)
  Kold_low = Lbound(Array,3)
  Kold_high = Ubound(Array,3)
  If Inew_low > Iold_low Or Inew_high < Iold_high _
    Or Jnew_low > Jold_low Or Jnew_high < Jold_high _
    Or Knew_low > Kold_low Or Knew_high < Kold_high Then
    Print "<E> Extend not performed, New array cuts into the old array."
    Print "    Operation not performed."
  Else
    Redim Work(Iold_low To Iold_high, _
               Jold_low To Jold_high, _
               Kold_low To Kold_high) As Double
    For I = Iold_low To Iold_high
      For J = Jold_low To Jold_high
        For K = Kold_low To Kold_high
          Work(I,J,K) = Array(I,J,K)
        Next K  
      Next J  
    Next I
    Redim Array(Inew_low To Inew_high, _
                Jnew_low To Jnew_high, _
                Knew_low To Knew_high) As Double
    For I = Inew_low To Inew_high
      For J = Jnew_low To Jnew_high
        For K = Knew_low To Knew_high
          Array(I,J,K) = 0
        Next K  
      Next J
    Next I
    For I = Iold_low To Iold_high
      For J = Jold_low To Jold_high
        For K = Kold_low To Kold_high
          Array(I,J,K) = Work(I,J,K)
        Next K  
      Next J  
    Next I  
    Array(3,2) = 300
  End If
End Sub  

Extend_1dim(Array_1D(),-2,10)
For I = -2 To 10
  Print I, Array_1D(I)
Next I 

Extend_2dim(Array_2D(),-2,10,-1,5)
For I = -2 To 10
  For J = -1 To 5
    Print I,J, Array_2D(I,J)
  Next J  
Next I 

 
End
